#include <stdio.h>
#include <limits.h>

int main (int argc, char *argv[])
{
	if (argc == 3 && strcmp(argv[1],"--grab")==0){
		char cmd[PATH_MAX];
		FILE *fin;
		close (2);
		sprintf (cmd,"/usr/lib/linuxconf/lib/netcat %s 97",argv[2]);
		fin = popen (cmd,"r");
		if (fin != NULL){
			char path[PATH_MAX];
			FILE *fout;
			sprintf (path,"/home/httpd/html/mrtg/data.%s",argv[2]);
			fout = fopen (path,"w");
			if (fout != NULL){
				char buf[1000];
				while (fgets(buf,sizeof(buf)-1,fin)!=NULL) fputs (buf,fout);
				fclose (fout);
			}
			pclose (fin);
			printf ("0\n");
			printf ("0\n");
			printf ("virtual\n");
			printf ("(grabing IP accounting from %s)\n",argv[2]);
		}
	}else if (argc == 6 && strcmp(argv[1],"--get")==0){
		const char *hsrc = argv[3];
		const char *hdst = argv[4];
		const char *pdst = argv[5];
		char path[PATH_MAX];
		FILE *fin;
		sprintf (path,"/home/httpd/html/mrtg/data.%s",argv[2]);
		fin = fopen (path,"r");
		if (fin != NULL){
			char buf[1000];
			int in = 0, out = 0;
			while (fgets(buf,sizeof(buf)-1,fin)!=NULL){
				char src[PATH_MAX],dst[PATH_MAX],srcp[PATH_MAX],dstp[PATH_MAX];
				int bytes;
				strcpy (dstp,"any");
				if (sscanf (buf,"%d %s %s %s %s",&bytes,src,dst,srcp,dstp)>=3){
					if (strcmp(src,hsrc)==0
						&& strcmp(dst,hdst)==0
						&& strcmp(dstp,pdst)==0){
						in = bytes;
					}else if (strcmp(src,hdst)==0
						&& strcmp(dst,hsrc)==0
						&& strcmp(srcp,pdst)==0){
						out = bytes;
					}
				}
			}
			fclose (fin);
			printf ("%d\n",in);
			printf ("%d\n",out);
			printf ("n/a\n");
			printf ("(%s -> %s:%s)\n",argv[2],argv[3],argv[4]);
		}
	}
	return 0;
}

